# Generated by Django 4.1.9 on 2023-06-24 12:20

import django.contrib.sites.managers
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):
    dependencies = [
        ("cursus", "0002_add_course_lesson_quota"),
        ("core", "0048_delete_personalicalurl"),
        ("sites", "0002_alter_domain_unique"),
        ("lesrooster", "0002_managed_by_app_label"),
    ]

    operations = [
        migrations.CreateModel(
            name="TimeboundCourseConfig",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("extended_data", models.JSONField(default=dict, editable=False)),
                (
                    "scheduled_slot_count",
                    models.PositiveSmallIntegerField(
                        blank=True,
                        null=True,
                        verbose_name="Number of slots this course is scheduled to fill per week",
                    ),
                ),
                (
                    "course",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="lr_timebound_course_configs",
                        to="cursus.course",
                        verbose_name="Course",
                    ),
                ),
                (
                    "site",
                    models.ForeignKey(
                        default=1,
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="sites.site",
                    ),
                ),
                (
                    "teachers",
                    models.ManyToManyField(
                        related_name="lr_timebound_course_configs",
                        to="core.person",
                        verbose_name="Teachers",
                    ),
                ),
                (
                    "validity_range",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="lr_timebound_course_configs",
                        to="lesrooster.validityrange",
                        verbose_name="Linked validity range",
                    ),
                ),
            ],
            options={
                "verbose_name": "Timebound course config",
                "verbose_name_plural": "Timebound course configs",
            },
            managers=[
                ("objects", django.contrib.sites.managers.CurrentSiteManager()),
            ],
        ),
        migrations.AddConstraint(
            model_name="timeboundcourseconfig",
            constraint=models.UniqueConstraint(
                fields=("course", "validity_range"),
                name="lr_unique_course_config_per_range",
            ),
        ),
    ]
